/** 考试规则维护 */
import React, { useState, useRef } from 'react';
import { useRequest, history } from 'umi';
import { PlusOutlined, TagsOutlined, UploadOutlined } from '@ant-design/icons';
import { Button, message, Input, Drawer, Modal, Col, Row, Space, Upload, Typography,Popconfirm } from 'antd';
import { PageContainer, FooterToolbar } from '@ant-design/pro-layout';
import type { ProColumns, ActionType } from '@ant-design/pro-table';
import ProTable from '@ant-design/pro-table';
import { BetaSchemaForm, ModalForm, ProFormText, ProFormTextArea } from '@ant-design/pro-form';
import type { ProDescriptionsItemProps } from '@ant-design/pro-descriptions';
import ProDescriptions from '@ant-design/pro-descriptions';
import type { FormValueType } from './components/UpdateForm';
import { querySubjectList, saveExamination, removeExamination, queryRulesList, removeRules } from '../service';
import type { TableListItem, TableListPagination } from './data';
import type { DataItem } from '@antv/data-set/lib/transform/tag-cloud';


/**
 * 添加考试规则
 *
 * @param fields
 */
const handleAdd = async (fields: TableListItem) => {
  const hide = message.loading('正在添加');

  try {
    await saveExamination({ ...fields });
    hide();
    message.success('添加成功');
    return true;
  } catch (error) {
    hide();
    message.error('添加失败请重试！');
    return false;
  }
};

/**
 * 更新考试
 *
 * @param fields
 */

const handleUpdate = async (fields: FormValueType, currentRow?: TableListItem) => {
  const hide = message.loading('正在更新');

  try {
    await saveExamination({
      ...currentRow,
      ...fields,
    });
    hide();
    message.success('操作成功');
    return true;
  } catch (error) {
    hide();
    message.error('操作失败请重试！');
    return false;
  }
};

/**
 * 删除考试规则
 *
 * @param selectedRows
 */
const handleRemove = async (selectedRows: TableListItem[], currentRow) => {
  const hide = message.loading('正在删除');
  if (!selectedRows) return true;

  try {
    await removeRules({
      key: selectedRows.map((row) => row.key),
    }, currentRow);
    hide();
    message.success('删除成功，即将刷新');
    return true;
  } catch (error) {
    hide();
    message.error('删除失败，请重试');
    return false;
  }
};

const ExaminationRules: React.FC = () => {
  /** 更新窗口的弹窗 */
  const [createModalVisible, handleCreateModalVisible] = useState<boolean>(false);
  const [detailModalVisible, handleDetailModalVisible] = useState<boolean>(false);
  const [updateModalVisible, handleUpdateModalVisible] = useState<boolean>(false);
  //const [registrationModalVisible, handleRegistrationModalVisible] = useState<boolean>(false);

  const actionRef = useRef<ActionType>();
  const [currentRow, setCurrentRow] = useState<TableListItem>();
  const [selectedRowsState, setSelectedRows] = useState<TableListItem[]>([]);

  /** 列表项定义 */
  const columns: ProColumns<TableListItem>[] = [
    {
      title: '序号',
      key: 'index',
      valueType: 'indexBorder',
      render: (text: React.ReactNode, _: any, index: number) => {
        if (actionRef && actionRef?.current && actionRef?.current?.pageInfo) {
          return `${(actionRef?.current?.pageInfo?.current - 1) * actionRef.current.pageInfo?.pageSize + (index + 1)
            }`;
        } else {
          return '';
        }
      },
      width: 48,
    },
    {
      title: '考试规则名称',
      dataIndex: 'rules_name',
      valueType: 'text',
      hideInTable: false,
      hideInForm: false,
      hideInSearch: true,
    },
    {
      title: '考试时间',
      width: 80,
      dataIndex: 'examination_time',
      valueType: 'text',
      sorter: false,
      hideInTable: false,
      hideInForm: false,
      hideInSearch: true,
      renderText: (val: string) => `${val} 分钟`,
    },
    {
      title: '关联主题',
      dataIndex: 'subject_name',
      valueType: 'text',
      hideInTable: false,
      hideInForm: false,
      hideInSearch: true,

    },
    {
      title: '关联主题',
      dataIndex: 'subject_id',
      valueType: 'text',
      hideInTable: true,
      hideInForm: false,
      hideInSearch: false,
      request: async () => {
        const { data: Items } = await querySubjectList({});
        // console.log(Items, ')))');

        const sinfo = []
        for (let i = 0; i < Items.list.length; i++) {
          // console.log(Items.list[i], ">>>")
          sinfo.push({ label: Items.list[i].subject_name, value: Items.list[i].subject_id })
        }
        console.log(sinfo, 'sinfo');
        const info = sinfo?.filter((item, idx, self) => {
          return item?.b_use === 1
        });
        return sinfo;
      },
    },
    {
      title: '创建时间',
      dataIndex: 'create_time',
      valueType: 'dateRange',
      sorter: false,
      hideInTable: false,
      hideInForm: false,
      hideInSearch: false,
      render: (dom, entity) => {
        return entity.create_time
      },
    },
    {
      title: '试卷数量',
      width: 80,
      dataIndex: 'paper_count',
      sorter: false,
      valueType: 'text',
      hideInSearch: true,
      hideInForm: true,
      hideInTable: false,
      renderText: (val: string) => `${val || '-'}`,
    },
    {
      title: '总分',
      width: 50,
      dataIndex: 'sum_score',
      sorter: false,
      valueType: 'text',
      hideInSearch: true,
      hideInForm: false,
      renderText: (val: string) => `${val || '-'} 分`,
    },
    {
      title: '通过线',
      width: 60,
      dataIndex: 'pass_score',
      sorter: false,
      valueType: 'text',
      hideInSearch: true,
      hideInForm: false,
      renderText: (val: string) => `${val || '-'} 分`,
    },
    {
      title: '操作',
      dataIndex: 'option',
      valueType: 'option',
      width: 100,
      render: (_dom: any, record: React.SetStateAction<TableListItem | undefined>) => {
        // console.log(record, 'record')
        return [
          // <a
          //   key="detail"
          //   onClick={() => {
          //     //console.log('entity', entity);
          //     setCurrentRow(record);
          //     handleDetailModalVisible(true);
          //   }}
          // >
          //   查看
          // </a>,
          <a
            key="update"
            onClick={() => {
              history.push('/examinationrules/attestation/step/' + record.id)
            }}
          >
            编辑
          </a>,
          <Popconfirm key="popconfirm" title={`确认删除当前考试吗?`} okText="是" cancelText="否"
                      onConfirm={async () => {
                        handleRemove([{ key: record?.id }], record); // 调用批量删除函数（如果接口不支持批量需要在service中处理）
                        setSelectedRows([]);
                        actionRef.current?.reloadAndRest?.();
                      }}
          >
            <Button type="link" danger disabled={record.b_use ? true : false}>删除</Button>
          </Popconfirm>
          // <a
          //   key="remove"
          //   onClick={() => {
          //     handleRemove([{ key: record?.id }], record); // 调用批量删除函数（如果接口不支持批量需要在service中处理）
          //     setSelectedRows([]);
          //     actionRef.current?.reloadAndRest?.();
          //   }}>
          //   删除
          // </a>,
          /*
          <a
            key="registration"
            onClick={() => {
              history.push(`/examination/option/registration/${record.examination_id}`);
              //setCurrentRow(record);
            }}
          >
            {record.b_use == 1 ? <Typography.Text type="success">已发布</Typography.Text> : <Typography.Text type="secondary">未发布</Typography.Text>}
          </a>*/,
        ]
      },
    },
  ];

  return (
    <PageContainer>
      <ProTable<TableListItem, TableListPagination>
        headerTitle={false}
        actionRef={actionRef}
        rowKey="examination_id"
        options={false}
        search={{
          labelWidth: 120,
        }}
        toolBarRender={() => [
          <Button
            type="primary"
            key="primary"
            onClick={() => {
              history.push('/examinationrules/attestation/step')
            }}
          >
            <PlusOutlined /> 新建资质考试规则
          </Button>,
        ]}
        request={async (value) => {
          const { create_time } = value;
          if (create_time) {
            value.start_time = create_time[0]
            value.end_time = create_time[1]
          }
          const _data = await queryRulesList(
            {
              ...value,
              rules_type: 1,
              page_number: value.current,
              page_size: value.pageSize
            }
          );

          return {
            current: _data?.pageNumber,
            data: _data?.table_List,
            pageSize: _data?.pageSize,
            total: _data?.totalRow || 0,
          };
        }}
        // dataSource={list}
        columns={columns}
        rowSelection={false}
      />
      {selectedRowsState?.length > 0 && (
        <FooterToolbar
          extra={
            <div>
              已选择{' '}
              <a
                style={{
                  fontWeight: 600,
                }}
              >
                {selectedRowsState.length}
              </a>{' '}
              项 &nbsp;&nbsp;
            </div>
          }
        >
          <Button
            onClick={async () => {
              await handleRemove(selectedRowsState);
              setSelectedRows([]);
              actionRef.current?.reloadAndRest?.();
            }}
          >
            批量删除
          </Button>
          <Button type="primary">批量审批</Button>
        </FooterToolbar>
      )}
      <Modal
        title={currentRow?.examination_name || '考试详细'}
        width="60%"
        visible={detailModalVisible}
        onCancel={() => {
          setCurrentRow(undefined); // 设置当前行
          handleDetailModalVisible(false);
        }}
        footer={null}
        centered
      >{console.log('currentRow', currentRow)}
        {currentRow?.name && (
          <ProDescriptions<TableListItem>
            column={2}
            /* title={currentRow?.name} */
            dataSource={currentRow}
            /*
              request={async () => ({
                data: currentRow || {},
              })}*/
            params={{
              id: currentRow?.examination_id,
            }}
            columns={
              columns
              //columns.slice(0, columns.length - 1) as ProDescriptionsItemProps<TableListItem>[]
            }
          />
        )}
      </Modal>

      <Modal
        title="新建考试"
        //
        width="60%"
        visible={createModalVisible}
        destroyOnClose
        onCancel={() => {
          handleCreateModalVisible(false);
        }}
        footer={null}
      >
        <BetaSchemaForm<DataItem>
          layout="horizontal"
          layoutType="Form"
          labelCol={{ span: 8 }}
          wrapperCol={{ span: 12 }}
          onFinish={async (values: any) => {
            // 表单处理
            console.log('columns:', columns);
            console.log('values:', values);

          }}
          submitter={{
            render: (props, doms) => (
              <Row>
                <Col span={12} offset={8}>
                  <Space>{doms}</Space>
                </Col>
              </Row>
            ),
          }}
          // action = ''
          title="新建"
          columns={columns}
        />
      </Modal>

      <Modal
        title="编辑"
        width="60%"
        visible={updateModalVisible}
        destroyOnClose
        onCancel={() => {
          handleUpdateModalVisible(false);
        }}
        footer={null}
      >
        {currentRow?.name && (
          <BetaSchemaForm<DataItem>
            layout="horizontal"
            layoutType="Form"
            labelCol={{ span: 8 }}
            wrapperCol={{ span: 12 }}
            onFinish={async (values) => {
              console.log(values);
            }}
            submitter={{
              render: (props, doms) => (
                <Row>
                  <Col span={12} offset={8}>
                    <Space>{doms}</Space>
                  </Col>
                </Row>
              ),
            }}
            // action = ''
            title="编辑"
            columns={getInitialValues(columns, currentRow)}
          />
        )}
      </Modal>

    </PageContainer>
  );
};

export default ExaminationRules;
